
local MakePlayerCharacter = require "prefabs/player_common"


local assets = {

        Asset( "ANIM", "anim/player_basic.zip" ),
        Asset( "ANIM", "anim/player_idles_shiver.zip" ),
        Asset( "ANIM", "anim/player_actions.zip" ),
        Asset( "ANIM", "anim/player_actions_axe.zip" ),
        Asset( "ANIM", "anim/player_actions_pickaxe.zip" ),
        Asset( "ANIM", "anim/player_actions_shovel.zip" ),
        Asset( "ANIM", "anim/player_actions_blowdart.zip" ),
        Asset( "ANIM", "anim/player_actions_eat.zip" ),
        Asset( "ANIM", "anim/player_actions_item.zip" ),
        Asset( "ANIM", "anim/player_actions_uniqueitem.zip" ),
        Asset( "ANIM", "anim/player_actions_bugnet.zip" ),
        Asset( "ANIM", "anim/player_actions_fishing.zip" ),
        Asset( "ANIM", "anim/player_actions_boomerang.zip" ),
        Asset( "ANIM", "anim/player_bush_hat.zip" ),
        Asset( "ANIM", "anim/player_attacks.zip" ),
        Asset( "ANIM", "anim/player_idles.zip" ),
        Asset( "ANIM", "anim/player_rebirth.zip" ),
        Asset( "ANIM", "anim/player_jump.zip" ),
        Asset( "ANIM", "anim/player_amulet_resurrect.zip" ),
        Asset( "ANIM", "anim/player_teleport.zip" ),
        Asset( "ANIM", "anim/wilson_fx.zip" ),
        Asset( "ANIM", "anim/player_one_man_band.zip" ),
        Asset( "ANIM", "anim/shadow_hands.zip" ),
        Asset( "SOUND", "sound/sfx.fsb" ),
        Asset( "SOUND", "sound/wilson.fsb" ),
        Asset( "ANIM", "anim/beard.zip" ),

		-- Don't forget to include your character's custom assets!
        Asset( "ANIM", "anim/kula.zip" ),
	Asset( "IMAGE", "images/kulatab.tex"),
        Asset( "ATLAS", "images/kulatab.xml"),
	Asset("IMAGE", "images/inventoryimages/lf.tex"),
	Asset("ATLAS", "images/inventoryimages/lf.xml"),
	Asset("IMAGE", "images/inventoryimages/yyy.tex"),
	Asset("ATLAS", "images/inventoryimages/yyy.xml"),
	Asset("IMAGE", "images/inventoryimages/qmb.tex"),
	Asset("ATLAS", "images/inventoryimages/qmb.xml"),
}

local prefabs = 
{
    "lf",
    "qmb",
    "yyy",
}

local start_inv = { 
"amulet",
}
local function applyupgrades(inst)
	local max_upgrades = 30
	local upgrades = math.min(inst.level, max_upgrades)
	local hunger_percent = inst.components.hunger:GetPercent()
	local health_percent = inst.components.health:GetPercent()
	local sanity_percent = inst.components.sanity:GetPercent()

	inst.components.hunger.max = math.ceil (80 + upgrades * 2) --200
	inst.components.health.maxhealth = math.ceil (60 + upgrades * 2 ) --200
	inst.components.sanity.max = math.ceil (200 + upgrades * 8) --440


    if TheWorld.state.issummer or (inst.components.temperature.current > 40) then
	inst.components.temperature.inherentinsulation = 0
    else
	inst.components.temperature.inherentinsulation = upgrades * upgrades
    end
	inst.components.combat.damagemultiplier = math.ceil (1.1 + upgrades / 60) --10
	
	inst.components.locomotor.walkspeed =  math.ceil (7 + upgrades / 7) --11
	inst.components.locomotor.runspeed = math.ceil (9 + upgrades / 6) --14
	
	
	inst.components.talker:Say("Level : ".. (inst.level))
                   if  inst.level  > 5 and  inst.level  < 7 then
                    inst.components.health:SetInvincible(true)
                                        inst.sg:GoToState("amulet_rebirth")
                            inst.components.talker:Say("我学会了占卜，同时觉醒光子亲和")
                                inst:DoTaskInTime(3, function()
                                               
                 inst.components.health:SetInvincible(false)                            
          
            end)

                   end
	
	if inst.level >29 then
    if not inst:HasTag("wizard") then
      inst.components.health:SetInvincible(true)
                        inst.sg:GoToState("amulet_rebirth")
		inst.components.talker:Say("我学会了星辰投射，同时觉醒欲火重生,现在的我无所不知无所不晓")
    inst:AddTag("wizard")
    inst.components.builder.ancient_bonus = 4 
        inst.components.builder.science_bonus = 2
        inst.components.health:StartRegen(3, 5)
    inst:DoTaskInTime(3, function()
                                               
                 inst.components.health:SetInvincible(false)                            
          
            end)

        
  else
    inst.components.builder.ancient_bonus = 4 
        inst.components.builder.science_bonus = 2
        inst.components.health:StartRegen(3, 5)
    inst.components.talker:Say("现在的我无所不知无所不晓")

  end
               -- inst.components.talker:Say("等级已满 ")



	end

	inst.components.hunger:SetPercent(hunger_percent)
	inst.components.health:SetPercent(health_percent)
	inst.components.sanity:SetPercent(sanity_percent)

end
local function oneat(inst, food)
	
	--if food and food.components.edible and food.components.edible.foodtype == "HELLO" then
  if food and food.components.edible and food.prefab == "corn" or food.prefab == "taffy" then
		--give an upgrade!
		inst.level = inst.level + 1
		applyupgrades(inst)	
		inst.SoundEmitter:PlaySound("dontstarve/characters/wx78/levelup")
  end
end
local function onpreload(inst, data)
	if data then
		if data.level then
			inst.level = data.level
			applyupgrades(inst)
			--re-set these from the save data, because of load-order clipping issues
			if data.health and data.health.health then inst.components.health.currenthealth = data.health.health end
			if data.hunger and data.hunger.hunger then inst.components.hunger.current = data.hunger.hunger end
			if data.sanity and data.sanity.current then inst.components.sanity.current = data.sanity.current end
			inst.components.health:DoDelta(0)
			inst.components.hunger:DoDelta(0)
			inst.components.sanity:DoDelta(0)
		end
	end

end

local function onsave(inst, data)
	data.level = inst.level
	data.charge_time = inst.charge_time
end

local common_postinit = function(inst)
    -- choose which sounds this character will play
    inst.soundsname = "wickerbottom"

    -- a minimap icon must be specified
    inst.entity:AddMiniMapEntity()
    inst.MiniMapEntity:SetIcon( "kula1.tex" ) 

   -- inst:AddTag("kulabuilder")
      inst:AddTag("bookbuilder")
    inst.ghostbuild = "ghost_willow_build"
    inst:AddTag("reader")
    inst:AddComponent("keyhandler")
	inst.components.keyhandler:AddActionListener("kula", KEY_V, "KEY_V")
        inst.components.keyhandler:AddActionListener("kula", KEY_F11, "KEY_F11")
               --inst.components.keyhandler:AddActionListener("kula", KEY_F5, "KEY_F5")
                inst.components.keyhandler:AddActionListener("kula", KEY_F12, "KEY_F12")
                inst.components.keyhandler:AddActionListener("kula", KEY_F8, "KEY_F8")

	inst.components.keyhandler:AddActionListener("kula", KEY_F1, "KEY_F1")

        inst.components.keyhandler:AddActionListener("kula", KEY_F5, "KEY_F5")
  inst.components.keyhandler:AddActionListener("kula", KEY_F2, "KEY_F2")
    inst.components.keyhandler:AddActionListener("kula", KEY_F3, "KEY_F3")
        inst.components.keyhandler:AddActionListener("kula", KEY_F4, "KEY_F4")
        inst.components.keyhandler:AddActionListener("kula", KEY_5, "KEY_5")
            inst.components.keyhandler:AddActionListener("kula", KEY_6, "KEY_6")
        inst.components.keyhandler:AddActionListener("kula", KEY_7, "KEY_7")
end



-----------------------------------------------技能



----------------------------------------------------切换为鬼术妖姬

local function KEY_F12fn(inst) --

      if not inst:HasTag("witch")  then
                            inst.sg:GoToState("book")
                            inst.components.health:SetInvincible(true)
                          inst.components.temperature:SetTemp(20)

            inst.components.locomotor:Stop()

                    inst.components.playercontroller:Enable(false)

local pt = Vector3(inst.Transform:GetWorldPosition())

                                 
                                    
                  
  

                 inst:DoTaskInTime(2.5, function()
inst.sg:GoToState("amulet_rebirth")
                      inst:DoTaskInTime(0.0001, function()

        local rain1 = SpawnPrefab("stafflight")
local rain2 = SpawnPrefab("stafflight")
local rain3 = SpawnPrefab("stafflight")
local rain4 = SpawnPrefab("stafflight")
local rain5 = SpawnPrefab("stafflight")
local rain6 = SpawnPrefab("stafflight")
local rain7 = SpawnPrefab("stafflight")
local rain8 = SpawnPrefab("stafflight")
                     rain1.Transform:SetPosition(pt.x+8, 0, pt.z+8)
                     rain2.Transform:SetPosition(pt.x-8, 0, pt.z-8)
                     rain3.Transform:SetPosition(pt.x+8, 0, pt.z-8)
                     rain4.Transform:SetPosition(pt.x-8, 0, pt.z+8)                                                   
                     rain5.Transform:SetPosition(pt.x+8, 0, pt.z)
                     rain6.Transform:SetPosition(pt.x-8, 0, pt.z)
                     rain7.Transform:SetPosition(pt.x, 0, pt.z-8)
                     rain8.Transform:SetPosition(pt.x, 0, pt.z+8)
rain1.gogogo = rain1:DoPeriodicTask(.03, function() rain1.Physics:SetMotorVelOverride(-4,5, -4 ) end)
rain2.gogogo = rain2:DoPeriodicTask(.03, function() rain2.Physics:SetMotorVelOverride(4,5, 4 ) end)
rain3.gogogo = rain3:DoPeriodicTask(.03, function() rain3.Physics:SetMotorVelOverride(-4,5, 4) end)
rain4.gogogo = rain4:DoPeriodicTask(.03, function() rain4.Physics:SetMotorVelOverride(4,5, -4 ) end)
rain5.gogogo = rain5:DoPeriodicTask(.03, function() rain5.Physics:SetMotorVelOverride(-4,5, 0 ) end)
rain6.gogogo = rain6:DoPeriodicTask(.03, function() rain6.Physics:SetMotorVelOverride(4,5, 0 ) end)
rain7.gogogo = rain7:DoPeriodicTask(.03, function() rain7.Physics:SetMotorVelOverride(0,5, 4 ) end)
rain8.gogogo = rain8:DoPeriodicTask(.03, function() rain8.Physics:SetMotorVelOverride(0,5, -4) end)

inst:DoTaskInTime(1.9, function()
  rain1:Remove()
  rain2:Remove()
  rain3:Remove()
  rain4:Remove()
  rain5:Remove()
  rain6:Remove()
  rain7:Remove()
  rain8:Remove()
end)
end)
end)
                 inst:DoTaskInTime(4.55, function()
                                                
       
                            inst.components.playercontroller:Enable(true)
                            inst.components.health:SetInvincible(false)  
                            inst:AddTag("witch")

                            end)  
        
        --inst:AddTag("down")
        --inst:AddTag("right")
        --inst:AddTag("up")
       else
               inst.sg:GoToState("book")
                            inst.components.health:SetInvincible(true)
                          inst.components.temperature:SetTemp(20)

            inst.components.locomotor:Stop()

                    inst.components.playercontroller:Enable(false)

local pt = Vector3(inst.Transform:GetWorldPosition())
                                                                     
                
                 inst:DoTaskInTime(2.5, function()
                              inst.sg:GoToState("amulet_rebirth")
                      inst:DoTaskInTime(0.0001, function()

        local rain1 = SpawnPrefab("stafflight")
local rain2 = SpawnPrefab("stafflight")
local rain3 = SpawnPrefab("stafflight")
local rain4 = SpawnPrefab("stafflight")
local rain5 = SpawnPrefab("stafflight")
local rain6 = SpawnPrefab("stafflight")
local rain7 = SpawnPrefab("stafflight")
local rain8 = SpawnPrefab("stafflight")
                     rain1.Transform:SetPosition(pt.x+8, 0, pt.z+8)
                     rain2.Transform:SetPosition(pt.x-8, 0, pt.z-8)
                     rain3.Transform:SetPosition(pt.x+8, 0, pt.z-8)
                     rain4.Transform:SetPosition(pt.x-8, 0, pt.z+8)                                                   
                     rain5.Transform:SetPosition(pt.x+8, 0, pt.z)
                     rain6.Transform:SetPosition(pt.x-8, 0, pt.z)
                     rain7.Transform:SetPosition(pt.x, 0, pt.z-8)
                     rain8.Transform:SetPosition(pt.x, 0, pt.z+8)
rain1.gogogo = rain1:DoPeriodicTask(.03, function() rain1.Physics:SetMotorVelOverride(-4,5, -4 ) end)
rain2.gogogo = rain2:DoPeriodicTask(.03, function() rain2.Physics:SetMotorVelOverride(4,5, 4 ) end)
rain3.gogogo = rain3:DoPeriodicTask(.03, function() rain3.Physics:SetMotorVelOverride(-4,5, 4) end)
rain4.gogogo = rain4:DoPeriodicTask(.03, function() rain4.Physics:SetMotorVelOverride(4,5, -4 ) end)
rain5.gogogo = rain5:DoPeriodicTask(.03, function() rain5.Physics:SetMotorVelOverride(-4,5, 0 ) end)
rain6.gogogo = rain6:DoPeriodicTask(.03, function() rain6.Physics:SetMotorVelOverride(4,5, 0 ) end)
rain7.gogogo = rain7:DoPeriodicTask(.03, function() rain7.Physics:SetMotorVelOverride(0,5, 4 ) end)
rain8.gogogo = rain8:DoPeriodicTask(.03, function() rain8.Physics:SetMotorVelOverride(0,5, -4) end)

inst:DoTaskInTime(1.9, function()
  rain1:Remove()
  rain2:Remove()
  rain3:Remove()
  rain4:Remove()
  rain5:Remove()
  rain6:Remove()
  rain7:Remove()
  rain8:Remove()
end)
end)
end)
                 inst:DoTaskInTime(4.55, function()
                                                
                            inst.components.playercontroller:Enable(true)
                            inst.components.health:SetInvincible(false)  
                        --inst:AddTag("witch")
             inst:RemoveTag("witch")
                            end)  
       -- inst:RemoveTag("witch")
        
      end

end
AddModRPCHandler("kula", "KEY_F12", KEY_F12fn)



---------------------------------------------------  传送术

local function KEY_Vfn( inst)    --  传送术



     local fin = true
   -- local x , y = TheInputProxy:GetOSCursorPos()
     local pos = TheInput:GetWorldPosition() 

         --local pos = gim:UpdateWithCursor(x0, y0, t, fin) 
   --local pos= Vector3(TheInputProxy:GetOSCursorPos())
   if not inst:HasTag("witch") then
   if not  inst.sexycooldown  then
    if not inst:HasTag("playerghost") then
   if  TheWorld.Map:IsAboveGroundAtPoint(pos:Get()) then
   	            inst.components.locomotor:Stop()
            inst.components.playercontroller:Enable(false) 
   inst.components.sanity:DoDelta(-1)
               inst.components.health:SetInvincible(true)
if not inst:HasTag("sound")  then
             inst.SoundEmitter:PlaySound("dontstarve/zg/willow/pound")
              inst:AddTag("sound")
inst:DoTaskInTime(1.5, function()
                     inst:RemoveTag("sound")                          
                                             
          
            end)
else
end
      
   inst.sexycooldown = true

    inst:Hide()
    inst.SoundEmitter:PlaySound("dontstarve/common/staff_blink")
    SpawnPrefab("small_puff").Transform:SetPosition(inst.Transform:GetWorldPosition())
    inst:DoTaskInTime(0.35, function(inst) 

 
    SpawnPrefab("small_puff").Transform:SetPosition(inst.Transform:GetWorldPosition())
    inst.SoundEmitter:PlaySound("dontstarve/common/staff_blink")

           inst.Transform:SetPosition(TheInput:GetWorldPosition():Get())
    inst:Show()
                  inst.components.health:SetInvincible(false)
    inst.components.playercontroller:Enable(true)
 inst.sexycooldown = false
end )


           else
               inst.components.talker:Say("瞬移到大海里面？那是一种作死的行为，我可没有那么愚蠢")
            end
           else
               inst.components.talker:Say("我想你应该知道，幽灵是没法使用魔法的")
            end
           else
               
            end
            else
               
            end

end
AddModRPCHandler("kula", "KEY_V", KEY_Vfn)




----------------------------------------恶意魔印--------


local function KEY_F1fn(inst) -----恶意魔印
     local max_upgrades = 30
     local upgrades = math.min(inst.level, max_upgrades)
      if  inst:HasTag("witch")  then
                 if not inst:HasTag("forcefield")  then
        
        if not inst.chargeincooldown then
    if  num and num > (6+upgrades/3) then 
    if not inst:HasTag("playerghost") then


   inst.chargeincooldown = true
      --onenter = function(inst, pos)
        local fire = SpawnPrefab("stafflight")             
                  local pos1 = inst:GetPosition()       
            fire.Transform:SetPosition(pos1.x, 0, pos1.z)
            local pos = TheInput:GetWorldPosition()
inst.AnimState:PlayAnimation("give")
inst.components.playercontroller:Enable(false)
        inst.components.locomotor:Stop()
        inst:DoTaskInTime(0.25, function()
fire.Transform:SetRotation( inst:GetAngleToPoint(pos:Get()) )
        
        fire.Physics:SetMotorVelOverride(25,0,0)

end)
inst:DoTaskInTime(0.3, function()
              fire.Physics:SetCollisionCallback(function(inst,other)

                if other ~= nil then

                if other and other.components.health and other.components.combat then

                if other.components.combat.target==GetPlayer() or GetPlayer().components.combat.target==other or other:HasTag("monster") then
            other.components.health:DoDelta(- 50 - upgrades * 5)
            other:AddTag("imprint")
                                          inst:DoTaskInTime(4, function()
                                other:RemoveTag("imprint")
                             end)
            local pt = fire:GetPosition()
       -- rain.Transform:SetPosition(pt.x, 0, pt.z)
        SpawnPrefab("explode_small").Transform:SetPosition(pt.x, 0, pt.z)
                            fire:Remove()

                if other.components.freezable then
            other.components.freezable:AddColdness(30 + upgrades* 4)
            other.components.freezable:SpawnShatterFX()

                end
                end
                end
         else       

 
   inst:DoTaskInTime(0.75, function()
        --rain.Physics:ClearMotorVelOverride()
        --rain.Physics:SetMotorVelOverride(pos.x,0,pos.z)
         local range = 5
                                local pos3 = Vector3(inst.Transform:GetWorldPosition())



                                local ents = TheSim:FindEntities(pos3.x,pos3.y,pos3.z, range)
            
                local fxtable = {"sanity_raise","sanity_lower","statue_transition","statue_transition_2","shadow_despawn"}
                inst:DoTaskInTime(0, function()
                inst:StartThread(function()
                                        for m,v in pairs(ents) do
                                            if not (v:HasTag("player")   and v:HasTag("deciduoustree") )   then
                                            if  v.components.health ~= nil  then
                                                    if not v.components.health:IsDead() then
                                                      if v ~= inst then
                                                    v.components.health:DoDelta(-5)
                                                     other.components.health:DoDelta(- 50 - upgrades * 5)
                              other:AddTag("imprint")
                              inst:DoTaskInTime(4, function()
                                other:RemoveTag("imprint")
                             end)
                              SpawnPrefab(fxtable[math.random(#fxtable)]).Transform:SetPosition(Vector3(v.Transform:GetWorldPosition()):Get())
                              local pt = fire:GetPosition()
       -- rain.Transform:SetPosition(pt.x, 0, pt.z)
        SpawnPrefab("explode_small").Transform:SetPosition(pt.x, 0, pt.z)
                            fire:Remove()
                                                       end
                                                  end
                                                end
                                        end
 
                                                                     if v.Transform then
                                                                                          
                           -- SpawnPrefab(fxtable[math.random(#fxtable)]).Transform:SetPosition(Vector3(n.Transform:GetWorldPosition()):Get())
                            Sleep(0)
                                        end
                                    end

                    end)
                           return true
                   end)

        

end)
 end
   end)
         inst.components.locomotor:Stop()
       -- local pt = inst:GetPosition()
       -- inst.Transform:SetPosition(pt.x, 0, pt.z)
        inst.components.playercontroller:Enable(true)
        inst.Physics:SetCollides(true)
        inst.AnimState:PlayAnimation("idle")
        inst:AddTag("Q")

  inst:RemoveTag("W")
  inst:RemoveTag("E")
end)

inst:DoTaskInTime(6 - upgrades/10, function()
        inst.chargeincooldown = false
      inst.components.talker:Say("恶魔印记冷却完毕")
end）
else

  end
  else
    inst.components.talker:Say("精神值不够")
  end
  else
    inst.components.talker:Say("魔法冷却中")
  end
  else
  end
else

      end
end
AddModRPCHandler("kula", "KEY_F1", KEY_F1fn)


-------------------------------------------- 魔影迷踪


local function KEY_F2fn(inst) --
     local max_upgrades = 30
     local upgrades = math.min(inst.level, max_upgrades)
      if  inst:HasTag("witch")  then
       

         if not inst:HasTag("trace") then
 
             if not inst.chargeincooldown then
    if  num and num > (6+upgrades/3) then 
    if not inst:HasTag("playerghost") then
                 --inst.chargeincooldown = true
   inst.chargeincooldown = true
           inst.components.health:SetInvincible(true)
            inst.components.locomotor:Stop()
            inst.components.playercontroller:Enable(false)          
              local rain = SpawnPrefab("stafflight")
                          local pos = inst:GetPosition()       
            rain.Transform:SetPosition(pos.x, 0, pos.z)
            local  pos1 = rain:GetPosition()
            rain:AddTag("rain")
  inst:AddTag("trace")
  inst:AddTag("W")
  inst:RemoveTag("Q")
  inst:RemoveTag("E")

     
           

            inst.AnimState:PlayAnimation("idle_shiver_pre")

            inst.AnimState:PushAnimation("idle_shiver_loop")

            inst.AnimState:PushAnimation("idle_shiver_pst",false)
     -- inst.SoundEmitter:PlaySound("dontstarve/zg/willow/call")

            inst.SoundEmitter:PlaySound("dontstarve/zg/willow/pound")

    inst:DoTaskInTime(0.01, function(inst)

            inst:AddTag("windman")
            inst.AnimState:SetBank("tornado")
            inst.AnimState:SetBuild("tornado")      
              
    --inst:SetBrain(brain)
           inst.AnimState:PlayAnimation("tornado_pre")
           inst.AnimState:PushAnimation("tornado_loop")
            inst.Transform:SetScale(1,1,1)
    inst.DynamicShadow:SetSize(1.3, .6)

            inst.components.sanity:DoDelta(-5-upgrades/6)
   inst:SetStateGraph("SGtornado")
                inst.sg:GoToState("idle")

 

            inst.components.hunger:Pause()

         

            inst.Physics:SetCollisionCallback(function(inst,other)

                if other and other.components.health and other.components.combat then

                if other.components.combat.target==GetPlayer() or GetPlayer().components.combat.target==other or other:HasTag("monster") then
            other.components.health:DoDelta(- 50 - upgrades * 5)

                if other.components.freezable then
            other.components.freezable:AddColdness(30 + upgrades* 4)
            other.components.freezable:SpawnShatterFX()
            inst.SoundEmitter:PlaySound("dontstarve/zg/willow/pound")
                end
                end
                end
                end)
            --inst.components.playercontroller:Enable(true)

                end)
 inst:DoTaskInTime(0.02, function(inst)
 

   inst:DoTaskInTime(0.03, function()


        inst.Physics:SetMotorVelOverride(25,0,0) end )
   inst:DoTaskInTime(0.25, function()
        inst.Physics:ClearMotorVelOverride()
        inst.Physics:SetMotorVelOverride(25,0,0) end )

   inst:DoTaskInTime(0.55, function()
        inst.Physics:ClearMotorVelOverride()
        inst.Physics:SetMotorVelOverride(25,0,0)
 end )
   inst:DoTaskInTime(0.75, function()
        inst.Physics:ClearMotorVelOverride()

        local pt = inst:GetPosition()
        inst.Transform:SetPosition(pt.x, 0, pt.z)

        inst.components.playercontroller:Enable(true)
                                        local range1 = 5
                                local pos3 = Vector3(inst.Transform:GetWorldPosition())
                                local ents = TheSim:FindEntities(pos3.x,pos3.y,pos3.z, range1)
            
                local fxtable = {"sanity_raise","sanity_lower","statue_transition","statue_transition_2","shadow_despawn"}
                inst:DoTaskInTime(0, function()
                inst:StartThread(function()
                                        for m,v in pairs(ents) do
                                            if not (v:HasTag("player")   and v:HasTag("deciduoustree") )   then
                                            if  v.components.health ~= nil  then
                                                    if not v.components.health:IsDead() then
                                                      if v ~= inst then
                                                        if v:HasTag("imprint") then

                                                    --v.components.health:DoDelta(-5)
                                                     v.components.health:DoDelta(- 200 - upgrades * 5)
                                                     v:RemoveTag("imprint")
                              --other:AddTag("imprint")
                              SpawnPrefab(fxtable[math.random(#fxtable)]).Transform:SetPosition(Vector3(v.Transform:GetWorldPosition()):Get())
                            else
                             -- v.components.health:DoDelta(-5)
                                                     v.components.health:DoDelta(- 100 - upgrades * 5)
                              --other:AddTag("imprint")
                              SpawnPrefab(fxtable[math.random(#fxtable)]).Transform:SetPosition(Vector3(v.Transform:GetWorldPosition()):Get())

                            end

                                                       end
                                                  end
                                                end
                                        end
 
                                                                     if v.Transform then
                                                                                          
                           -- SpawnPrefab(fxtable[math.random(#fxtable)]).Transform:SetPosition(Vector3(n.Transform:GetWorldPosition()):Get())
                            Sleep(0)
                                        end
                                    end

                    end)
                           return true
                   end)


end )
end )


            inst.components.locomotor:Stop()
            inst.components.playercontroller:Enable(false)
            inst.SoundEmitter:PlaySound("dontstarve_DLC001/creatures/glommer/foot_ground")
            inst.AnimState:PlayAnimation("tornado_pst")

    inst:DoTaskInTime(0.86, function(inst)
            inst:RemoveTag("windman")
            --inst:RemoveTag("mossling_spin")
            inst.AnimState:SetBank("wilson")
            inst.AnimState:SetBuild("kula")
            inst:SetStateGraph("SGwilson")
            inst.AnimState:PlayAnimation("idle")

            inst.Transform:SetScale(1,1,1)
    inst.DynamicShadow:SetSize(1.3, .6)

            inst.components.health:SetInvincible(false)


            inst.components.hunger:Resume()

            inst.components.temperature:SetTemp(nil)

            inst.Physics:SetCollisionCallback(nil)
            inst.components.playercontroller:Enable(true)


                end) 
    inst:DoTaskInTime(3, function()
  rain:Remove()
  inst:RemoveTag("trace")
 
end)
    inst:DoTaskInTime(10 - upgrades/6, function(inst)
      inst.chargeincooldown = false
      inst.components.talker:Say("魔影迷踪冷却完毕")
            

                end) 
                    else
  --inst.components.talker:Say("魔影迷踪冷却中")
  end
  else
  inst.components.talker:Say("没有足够的精神值")
  end

  else
  inst.components.talker:Say("魔影迷踪冷却中")
  end
  else
    local x,y,z = inst.Transform:GetWorldPosition();
    local range = 300
    local ents = TheSim:FindEntities(x,y,z,range)
    for k,v in pairs(ents) do
      if v:HasTag("rain") then
        
                                local range1 = 5
                                local pos3 = Vector3(inst.Transform:GetWorldPosition())
                                local ents = TheSim:FindEntities(pos3.x,pos3.y,pos3.z, range1)
            
                local fxtable = {"sanity_raise","sanity_lower","statue_transition","statue_transition_2","shadow_despawn"}
                inst:DoTaskInTime(0, function()
                inst:StartThread(function()
                                        for m,v in pairs(ents) do
                                            if not (v:HasTag("player")   and v:HasTag("deciduoustree") )   then
                                            if  v.components.health ~= nil  then
                                                    if not v.components.health:IsDead() then
                                                      if v ~= inst then
                                                        if v:HasTag("imprint") then

                                                    --v.components.health:DoDelta(-5)
                                                     v.components.health:DoDelta(- 200 - upgrades * 5)
                                                     v:RemoveTag("imprint")
                              --other:AddTag("imprint")
                              SpawnPrefab(fxtable[math.random(#fxtable)]).Transform:SetPosition(Vector3(v.Transform:GetWorldPosition()):Get())
                            else
                             -- v.components.health:DoDelta(-5)
                                                     v.components.health:DoDelta(- 100 - upgrades * 5)
                              --other:AddTag("imprint")
                              SpawnPrefab(fxtable[math.random(#fxtable)]).Transform:SetPosition(Vector3(v.Transform:GetWorldPosition()):Get())

                            end

                                                       end
                                                  end
                                                end
                                        end
 
                                                                     if v.Transform then
                                                                                          
                           -- SpawnPrefab(fxtable[math.random(#fxtable)]).Transform:SetPosition(Vector3(n.Transform:GetWorldPosition()):Get())
                            Sleep(0)
                                        end
                                    end

                    end)
                           return true
                   end)
inst:DoTaskInTime(0.15, function()
                local pos1 = v:GetPosition()
inst.Transform:SetPosition(pos1.x, 0, pos1.z)
    SpawnPrefab("small_puff").Transform:SetPosition(inst.Transform:GetWorldPosition())
    inst.SoundEmitter:PlaySound("dontstarve/common/staff_blink")
      inst:RemoveTag("trace")
      v:RemoveTag("rain")
      v:Remove()
      end)

      end
 

end
                                 
                end 

      
      end

end
AddModRPCHandler("kula", "KEY_F2", KEY_F2fn)


------------------------------------------幻影锁链


local function KEY_F3fn(inst) --
     local max_upgrades = 30
     local upgrades = math.min(inst.level, max_upgrades)
      if  inst:HasTag("witch")  then
         local range = 10
                                local pos3 = Vector3(inst.Transform:GetWorldPosition())



                                local ents = TheSim:FindEntities(pos3.x,pos3.y,pos3.z, range)
            
                local fxtable = {"sanity_raise","sanity_lower","statue_transition","statue_transition_2","shadow_despawn"}
                inst:DoTaskInTime(0, function()
                inst:StartThread(function()
                                        for m,v in pairs(ents) do
                                            if not (v:HasTag("player")   and v:HasTag("deciduoustree") )   then
                                            if  v.components.health ~= nil  then
                                                    if not v.components.health:IsDead() then
                                                      if v ~= inst then
                                                    if v:HasTag("imprint") then

                                                    --v.components.health:DoDelta(-5)
                                                     v.components.health:DoDelta(- 200 - upgrades * 5)
                                                     v:RemoveTag("imprint")
                              --other:AddTag("imprint")
                              SpawnPrefab(fxtable[math.random(#fxtable)]).Transform:SetPosition(Vector3(v.Transform:GetWorldPosition()):Get())
                            else
                             -- v.components.health:DoDelta(-5)
                                                     v.components.health:DoDelta(- 100 - upgrades * 5)
                              --other:AddTag("imprint")
                              SpawnPrefab(fxtable[math.random(#fxtable)]).Transform:SetPosition(Vector3(v.Transform:GetWorldPosition()):Get())

                            end
                                                       end
                                                  end
                                                end
                                        end
                                        if v.brain  then
                                          SpawnPrefab("lightning_rod_fx").Transform:SetPosition(v.Transform:GetWorldPosition())
            v.brain:Stop() 
            inst:DoTaskInTime(3, function()                                                                                                                     
           v.brain:Start()
          end)           
     end
        if v.components.combat then
            v.components.combat:SetTarget(nil)
        end
        if v.components.locomotor then
            v.components.locomotor:Stop()
        end
                                                                     if v.Transform then
                                                                                          local fireringfx = SpawnPrefab("firering_fx")
      fireringfx.Transform:SetPosition(inst.Transform:GetWorldPosition())
      fireringfx.Transform:SetRotation(inst.Transform:GetRotation())
                           -- SpawnPrefab(fxtable[math.random(#fxtable)]).Transform:SetPosition(Vector3(n.Transform:GetWorldPosition()):Get())
                            Sleep(0)
                                        end
                                    end

                    end)
                           return true
                   end)
        

      end

end
AddModRPCHandler("kula", "KEY_F3", KEY_F3fn)


---------------------------------------故技重施


local function KEY_F4fn(inst) --
     local max_upgrades = 30
     local upgrades = math.min(inst.level, max_upgrades)
      if  inst:HasTag("witch")  then
        

      end

end
AddModRPCHandler("kula", "KEY_F4", KEY_F4fn)



local function lighton(inst, data) --light aura

             local max_upgrades = 30
     local upgrades = math.min(inst.level, max_upgrades)

        if  upgrades > 5 then

if TheWorld.state.isnight  then
    local light = inst.entity:AddLight()
    inst.Light:Enable(true)
    inst.Light:SetRadius(5)
    inst.Light:SetFalloff(.4)
    inst.Light:SetIntensity(.5)
    inst.Light:SetColour(197/255, 197/255, 50/255)
elseif TheWorld.state.isday then
    local light = inst.entity:AddLight()
    light:SetIntensity(0)
    light:SetRadius(0)
    light:SetFalloff(0)
    light:Enable(false)
    light:SetColour(0/255, 0/255, 0/255)
    
elseif TheWorld.state.isdusk then
    local light = inst.entity:AddLight()
    light:SetIntensity(0)
    light:SetRadius(0)
    light:SetFalloff(0)
    light:Enable(false)
    light:SetColour(0/255, 0/255, 0/255)
    end

                  else
              
            end

end


local master_postinit = function(inst)


	inst.level = 0
	inst.components.eater:SetOnEatFn(oneat)
	applyupgrades(inst)	
	-- choose which sounds this character will play
	inst.soundsname = "willow"
	-- Stats	
	inst.components.health:SetMaxHealth(60)
        --inst.components.health:StartRegen(3, 5)
	inst.components.hunger:SetMax(80)
	inst.components.sanity:SetMax(200)
        inst.components.sanity.dapperness = (TUNING.DAPPERNESS_HUGE * 2)
        local max_upgrades = 30
     local upgrades = math.min(inst.level, max_upgrades)

        --if  upgrades > 5 then

        inst.components.health.fire_damage_scale = 0	
     -- end
	inst.components.locomotor.walkspeed = 7
	inst.components.locomotor.runspeed = 9
        if  upgrades > 29 then
	inst.components.builder.ancient_bonus = 4 
        inst.components.builder.science_bonus = 2
        inst.components.health:StartRegen(3, 5)
    end
        inst.components.builder.magic_bonus = 3


        --[[
            local old_GetAttacked = inst.components.combat.GetAttacked
    function inst.components.combat.GetAttacked(attacker, damage, weapon, stimuli)
        local x,y,z = inst.Transform:GetWorldPosition()
        --if attacker then

        if math.random() < .4 then

     local num = inst.components.health and inst.components.health.current

          -- if  num and num > 0 then 

    if not inst:HasTag("playerghost") then

                        if not inst:HasTag("windman") then
                        inst:AddTag("windman")
                                inst:AddTag("forcefield")
                                inst.components.health:SetInvincible(true)

            inst.components.locomotor:Stop()
            inst.components.playercontroller:Enable(false) 
            inst.AnimState:SetBank("tornado")
            inst.AnimState:SetBuild("tornado")  

              

           inst.AnimState:PlayAnimation("tornado_pre")
           inst.AnimState:PushAnimation("tornado_loop")
            inst.Transform:SetScale(1,1,1)
    inst.DynamicShadow:SetSize(1.3, .6)
       inst:SetStateGraph("SGtornado")
                inst.sg:GoToState("idle")

            inst.components.locomotor:Stop()
            inst.components.playercontroller:Enable(false) 
                                          local fireringfx = SpawnPrefab("firering_fx")
      fireringfx.Transform:SetPosition(inst.Transform:GetWorldPosition())
      fireringfx.Transform:SetRotation(inst.Transform:GetRotation())                                                                                                    
                                        local range = 3

                                                                local p = Vector3(inst.Transform:GetWorldPosition())
                                local ents2 = TheSim:FindEntities(p.x,p.y,p.z, range)
                                 for k,v in pairs(ents2) do
                                                                                    if not (v:HasTag("player") and v.components.health:IsDead() and v.components.health ~= nil and v:HasTag("deciduoustree") ) then
                                                 if   v.components.health ~= nil  then
                                                      if v ~= inst then
                                            v.components.health:DoDelta(-5)

                                                        local pt01 = inst:GetPosition()
       local pt02 = v:GetPosition()
        if v.brain ~= nil then
            v.brain:Stop()
          
                                                                       
        end

        if v.components.combat ~= nil then
            v.components.combat:SetTarget(nil)
        end

        if v.components.locomotor ~= nil then
            v.components.locomotor:Stop()
        end
                   if v.brain ~= nil then
              inst:DoTaskInTime(3, function()                                        
                                                                            
                        v.brain:Start()
                   end)       
            end
       v.Transform:SetPosition(5+pt02.x, 0, 5+pt02.z)
     
                                                end
                                                end
                                                end
                                                end



                                     
    inst:DoTaskInTime(2.5, function()
      if  inst:HasTag("windman") then
        fireringfx:Remove()  
     inst:RemoveTag("windman")
          inst:RemoveTag("forcefield")
            --inst:RemoveTag("mossling_spin")
            inst.AnimState:SetBank("wilson")
            inst.AnimState:SetBuild("kula")
            inst:SetStateGraph("SGwilson")
            inst.AnimState:PlayAnimation("idle")

            inst.Transform:SetScale(1,1,1)
    inst.DynamicShadow:SetSize(1.3, .6)
                   inst.components.health:SetInvincible(false)

            --inst.components.locomotor:Stop()
            inst.components.playercontroller:Enable(true) 
          end
            end)
                  end   
                 -- else

                 -- end
                   else

                end

        
                else
              return old_GetAttacked(attacker, damage, weapon, stimuli)
                end  
    end]]

       inst:ListenForEvent("sanitydelta", lighton)
	inst.OnSave = onsave
	inst.OnPreLoad = onpreload
end

return MakePlayerCharacter("kula", prefabs, assets, common_postinit, master_postinit, start_inv)
